import hou

from controlVariables import *
from uENode import *
from stdNetworkNodes import *

from lots import *
from buildings import *

# ===========================================================
#                uELoadMapNodeFactory
# ===========================================================
class uELoadMapNodeFactory:
	def __init__(self):
		self.__createContainer()
	def getContainer(self):
		return self.geo
	def __createContainer(self):
		self.geo = hou.node('/obj').createNode('geo')
		controlVariables.geo = self.geo
		#delete the file node
		for n in self.geo.children():
			n.destroy()
	def createNode(self,nodeName):
		if (nodeName == 'majorRoads'): 
			outputNode = LoadMapMajorRoads()
		elif (nodeName == 'minorRoads'): 
			outputNode = Null_uENode()
		elif (nodeName == 'blocks'): 
			outputNode = Blocks()
		elif (nodeName == 'lots'):
			outputNode = Lots()
		elif (nodeName == 'buildings'):
			outputNode = Buildings()
		elif (nodeName == 'finalAppearance'): 
			outputNode = FinalAppearance()
		elif (nodeName == 'floor'): 
			outputNode = Floor()
		elif (nodeName == 'filter'): 
			outputNode = ConstructionFilter()
		elif (nodeName == 'stats'):
			outputNode = Stats()
		outputNode.setContainer(self.geo)
		outputNode.construct()
		return outputNode
	def finishConstruction(self):
		self.geo.setDisplayFlag(True)
		for n in self.geo.children():
			n.moveToGoodPosition()			
		for n in hou.node('/obj').children():
			n.moveToGoodPosition()

# ===========================================================
#                LoadMapMajorRoads
# ===========================================================
class LoadMapMajorRoads(urbanEngineNode):
	def getNodeName(self):
		return 'MajorRoads'

	def __init__(self):
		urbanEngineNode.__init__(self, False)

	def __carregarMapaCiutatReal(self,tra):
		tra.parm('file').set(controlVariables.loadMap)#use the map
		tra.parm('usecop1').set(0)
		return tra

	def __esborrarPrimitivaExterior(self,tra):
		dele = self.geo.createNode('delete')
		dele.setFirstInput(tra)
		dele.parm('pattern').set('0')
		return dele

	def construct(self):
		tra = self.geo.createNode('trace')
		tra = self.__carregarMapaCiutatReal(tra)
		tra.parm('thresh').set(controlVariables.traceThreshold)
		tra.parm('doresample').set(1)
		tra.parm('step').set(15)

		if (controlVariables.needsDelete == 'yes'):
			tra = self.__esborrarPrimitivaExterior(tra)

		self.first = tra
		self.last = tra
