import sys
import hou

from controlVariables import *

print "  Streets module imported"

class streets:
	def streets(self,scale):

		geo = controlVariables.geo

		#delete all of the primitives but one at the time
		del3 = geo.createNode('delete')
		del3.setFirstInput(scale)
		del3.parm('negate').set(1)
		del3.parm('affectnumber').set(0)
		del3.parm('group').set(r'`stamp("../copy1","cy",0)`')
		
		#compute de lot area
		mea = geo.createNode('measure')
		mea.setName('measureLot')
		mea.parm('override').set(1) #compute the areas
		mea.parm('type').set(1) #override name
		mea.parm('attribname').set('areaLot')
		mea.setFirstInput(del3)

		#intercale the primitive with an array of "boxes"
		bou = geo.createNode('bound')
		bou.setFirstInput(mea)
		bou.parm('boundtype1').set(1)
	
		box = geo.createNode('box')
		box.setFirstInput(bou)
		box.parm('type').set(1) #change the type to polygon mesh
	
		nbox = self.seleccionarTerra(geo,box)
	
		#create disconnected primitives
		poli = geo.createNode('polyextrude')
		poli.setName('blockSize')
		poli.setFirstInput(nbox)
		poli.parm('lsx').set(controlVariables.blockSizex)
		poli.parm('lsy').set(controlVariables.blockSizey)
		poli.parm('outputside').set(0)

		poli2 = geo.createNode('polyextrude')
		poli2.setFirstInput(poli)
		poli2.parm('ltz').set(-1)
		poli2.parm('outputback').set(1)
	
		poli2 = self.rotar(geo,poli2)
		
		poli2 = self.intersecar(geo,poli2,del3)

		#copy all of the operations
		copy = geo.createNode('copy')
		copy.setFirstInput(poli2)
		copy.parm('stamp').set(1)
		copy.parm('param1').set('cy') 
		copy.parm('val1').setExpression("$CY") #the value is the copy number
		#if (controlVariables.districtMap!=None) | (controlVariables.pattern == 'voronoi'):
		copy.parm('ncy').setExpression('nprims("../' + scale.name() + '")')
		#else:
		#	copy.parm('ncy').setExpression('nprims("../trace1")')
		
		return copy, box


	def seleccionarTerra(self,geo,box):
		#center the pivot point of the box
		trans = geo.createNode('xform') 
		trans.setName('scaleLots')
		trans.setFirstInput(box)
		trans.parm('px').setExpression("$CEX") #CE is the center of the object
		trans.parm('py').setExpression("$CEY")
		trans.parm('pz').setExpression("$CEZ")
		trans.parm('sx').set(1.1)
		trans.parm('sy').set(1.1)
		trans.parm('sz').set(1.1)
		
		#delete all the points but the bottom ones
		del4 = geo.createNode('delete')
		del4.setFirstInput(trans)
		del4.parm('entity').set(1) #change the entity type to points
		del4.parm('groupop').set(2) #delete by expression
		del4.parm('filter').setExpression("$TZ>$ZMIN") #all of the points where the z component is greater than the minimum
		
		return del4
	
	
	def rotar(self,geo,poli2):
		trans2 = geo.createNode('xform')
		trans2.setName('rotation')
		trans2.setFirstInput(poli2)
		trans2.parm('px').setExpression("$CEX") #CE is the center of the object
		trans2.parm('py').setExpression("$CEY")
		trans2.parm('pz').setExpression("$CEZ")
		if controlVariables.pattern != 'grid':
			if controlVariables.streetsAngle == 'random':
				trans2.parm('rz').setExpression('360*(rand(stamp("../copy1","cy",0)))') #rotate a random angle for each node
			else:
				trans2.parm('rz').setExpression(controlVariables.streetsAngle)
				
		return trans2
	

	def intersecar(self,geo,poli2,del3):
		#intersect the current primitive with the array of boxes
		cook = geo.createNode('cookie')
		cook.setFirstInput(poli2)
		cook.setInput(1,del3)
		cook.parm('boolop').set(4) #change the operation to 'user defined'
		cook.parm('outsideB').set(1)
		cook.parm('tol3d').set(1.9404600607231259e-005) #to correct errors
		
		return cook
	