import sys
import hou

from simpleBuilding import *
from uENode import *
from controlVariables import *

class Buildings(urbanEngineNode):
	def __init__(self):
		urbanEngineNode.__init__(self)
	def getNodeName(self):
		return 'Buildings'

	def construct(self):
		aNullNode = self.geo.createNode('null')
		aNullNode.setName('lotInput')
		aNullNode.setFirstInput(self.first)

		#delete all of the primitives but one at the time
		del6 = self.geo.createNode('delete')
		del6.setName('selectLot')
		del6.parm('affectnumber').set(0)
		del6.parm('group').set(r'`stamp("../finalcp","ccy",0)`')
		del6.parm('negate').set(1)
		del6.setFirstInput(aNullNode)

		ed = self.carregarEdifici()

		rev = None
		if (controlVariables.needsReverse == 'Yes'):
			rev = self.geo.createNode('reverse')
			rev.setFirstInput(del6)
		else:
			rev = del6

		creep = self.encaixar(ed,rev)	
		xform = self.centrar(creep)

		copy2 = self.geo.createNode('copy')
		copy2.setName('finalcp')
		copy2.parm('ncy').setExpression('nprims("../lotInput")') #number of copies
		copy2.parm('stamp').set(1)
		copy2.parm('param1').set('ccy') 
		copy2.parm('val1').setExpression("$CY") #the value is the copy number
		copy2.setFirstInput(xform)

		self.last = copy2
	
	def carregarEdifici(self):
		theBuilding = self.geo.createNode('buildingHDA')
		theBuilding.parm('boxHeight').setExpression(self.__FloorsExpression())
		ed = self.geo.createNode('xform')
		ed.parm('sx').set(6)
		ed.parm('sy').set(6/0.15)
		ed.parm('sz').set(8)
		if controlVariables.districtMap != None:
			ed.parm('ry').set(180)
		ed.setFirstInput(theBuilding)

		#ed = self.geo.createNode('box')
		#ed.parm('type').set(1)
		#ed.parm('sizex').set(6)
		
		return ed


	def encaixar(self,ed,rev):
		creep = self.geo.createNode('creep')
		creep.setFirstInput(ed)
		creep.setInput(1,rev)
		creep.parm('tx').set(0.5)
		creep.parm('ty').set(0.5)
		creep.parm('sx').set(0.166667)
		creep.parm('sy').set(1)
		creep.parm('sz').set(0.005)
		
		return creep


	def centrar(self,creep):
		xform = self.geo.createNode('xform')
		xform.setFirstInput(creep)
		xform.parm('px').setExpression('$CEX')
		xform.parm('py').setExpression('$CEY')
		xform.parm('pz').setExpression('$ZMIN')
		xform.parm('sz').setExpression('(' + self.__FloorsExpression()+')*0.2')
	
		return xform
	
	def __FloorsExpression(self):
		#floors: '2+floor(6*rand(stamp("../finalcp","ccy",0)))'
		#height: '(2+floor(6*rand(stamp("../finalcp","ccy",0))))*0.2'
		centroid_x = 'centroid("../selectLot",D_X)'
		centroid_y = 'centroid("../selectLot",D_Y)'
		bbx = 'bbox("../selectLot",D_XSIZE)'
		return '2+floor(6*rand(' + centroid_x + '+' + centroid_y + '*' + bbx + '))'