import sys
import hou

from controlVariables import *

class compositing:

	def compositing(self):

		for n in hou.node('/img').children():
			n.destroy()

		comp = hou.node('/img').createNode('img')
	
		myP = self.carregarImatgeVex(comp)
		
		myP = self.seleccionarMarges(comp,myP)

		#turn it into black and white
		myP = self.blancNegre(comp,myP)

		#thicken the lines, darken the image AND add land use map (if needed)
		myP = self.eixamplarEnfosquirLinies(comp,myP)
		myP.setName('final')


		#separate the districts
		if controlVariables.districtMap != None:
			distfile = comp.createNode('file')
			distfile.parm('filename1').set(controlVariables.districtMap)
	
			scale2 = comp.createNode('scale')
			scale2.setFirstInput(distfile)
			scale2.setInput(1,myP)
			scale2.parm('scaletype').set(3)
	
			scale2 = self.seleccionarMarges(comp,scale2)
			
			#turn it into black and white
			scale2 = self.blancNegre(comp,scale2)

			#thicken the lines
			scale2 = self.eixamplarEnfosquirLinies(comp,scale2)
	
			inv3 = comp.createNode('invert')
			inv3.setFirstInput(scale2)
	
			op = hou.node('/img/img1/final')
			hou.node('/img/img1/final').setName('op')
			
			inv4 = comp.createNode('invert')
			inv4.setFirstInput(op)
	
			add = comp.createNode('add')
			add.setFirstInput(inv3)
			add.setInput(1,inv4)
			add.setName('final')
	

		for n in comp.children():
			n.moveToGoodPosition()
	

	def doWater(self,comp,myP):

		comp = hou.node('/img/img1')
	
		file = comp.createNode('file')
		file.parm('filename1').set(controlVariables.waterMap)
	
		scale = comp.createNode('scale')
		scale.setFirstInput(file)
		scale.setInput(1,myP)
		scale.parm('scaletype').set(3)
	
		min = comp.createNode('min')
		min.setFirstInput(scale)
		min.setInput(1,myP)
	
		return min


	def carregarImatgeVex(self,comp):
		col = comp.createNode('color')
		col.parm('overridesize').set(1)
		col.parm('size1').set(1828)
		col.parm('size2').set(1332)

		myP = comp.createNode('myPattern')
		myP.setFirstInput(col)
		
		return myP

	
	def seleccionarMarges(self,comp,myP):
		edge = comp.createNode('edge')
		edge.setFirstInput(myP)
		
		return edge
		
	
	def blancNegre(self,comp,myP):
		mono = comp.createNode('mono')
		mono.setFirstInput(myP)
		
		#turn black into white and white into black
		inv = comp.createNode('invert')
		inv.setFirstInput(mono)
		
		return inv


	def eixamplarEnfosquirLinies(self,comp,myP):
		blur = comp.createNode('blur')

		if controlVariables.waterMap != None:
			aux = self.doWater(comp,myP)
			blur.setFirstInput(aux)
			controlVariables.waterMap == None
		else:
			blur.setFirstInput(myP)
		blur.parm('blursize').set(30)
		
		
		lim = comp.createNode('limit')
		lim.setFirstInput(blur)
		lim.parm('clamp').set(1)
		lim.parm('lval').set(0.99)
		#lim.setName('final')
		
		return lim
