import sys
import hou

from controlVariables import *
from density import *

class densityRadial(density):

	def density(self,type,glo,vec):

		sur = controlVariables.sur
		
		cons = sur.node('constant1')
		
		#compute the distance between the center point and the current point
		dist = sur.createNode('distance')
		dist.setFirstInput(vec)
		dist.setInput(1,cons)
		
		#make the frequency decreasing instead of increasing
		comp = sur.createNode('complement')
		comp.setFirstInput(dist)

		#have control of the decrency of the frequency
		ramp = sur.createNode('ramps')
		ramp.setFirstInput(comp)
		ramp.parm('freq').set(0.93)
		
		fltovec2 = sur.createNode('floattovec')
		fltovec2.setFirstInput(ramp)
		fltovec2.setInput(1,ramp)
		fltovec2.setInput(2,ramp)
		
		return fltovec2