import sys
import hou

from voronoise import *
from grid import *
from radial import *
from compositing import *

from controlVariables import *

class districts(pattern):

	def districts(self,type):

		controlVariables.distColor1, controlVariables.distColor2, controlVariables.distColor3

		sur = controlVariables.sur

		glo = sur.createNode('global')
		
		mapfloat = sur.createNode('vectofloat')
		#the districts map
		if type == 'surface':
			map = sur.createNode('texture')
			map.parm('map').set(controlVariables.districtMap)
			map.setInput(1,glo,11)
			map.setInput(2,glo,12)
			mapfloat.setFirstInput(map)
		elif type == 'filter':
			map = sur.createNode('colormap')
			map.parm('cmap').set(controlVariables.districtMap)
			map.setInput(1,glo,22)
			map.setInput(2,glo,23)
			mapfloat.setFirstInput(map)

			
		if controlVariables.distColor1 != None:
			#determine voronoi color
			if controlVariables.distColor1=='red':
				red = sur.createNode('constant')
				red.parm('consttype').set(16)
				red.parm('colordefr').set(1)
				voronoiColor = sur.createNode('vectofloat')
				voronoiColor.setFirstInput(red)

			elif controlVariables.distColor1=='green':
				green = sur.createNode('constant')
				green.parm('consttype').set(16)
				green.parm('colordefb').set(1)
				voronoiColor = sur.createNode('vectofloat')
				voronoiColor.setFirstInput(green)

			elif controlVariables.distColor1=='blue':
				blue = sur.createNode('constant')
				blue.parm('consttype').set(16)
				blue.parm('colordefg').set(1)
				voronoiColor = sur.createNode('vectofloat')
				voronoiColor.setFirstInput(blue)
			#compare color to map
			c11 = sur.createNode('compare')
			c11.setFirstInput(voronoiColor)
			c11.setInput(1,mapfloat)
			c12 = sur.createNode('compare')
			c12.setFirstInput(voronoiColor,1)
			c12.setInput(1,mapfloat,1)
			c13 = sur.createNode('compare')
			c13.setFirstInput(voronoiColor,2)
			c13.setInput(1,mapfloat,2)
			
			voronoiand = sur.createNode('and')
			voronoiand.setFirstInput(c11)
			voronoiand.setInput(1,c12)
			voronoiand.setInput(2,c13)
			
			if1 = sur.createNode('if')
			if1.setFirstInput(voronoiand)
			controlVariables.sur = if1
			controlVariables.pattern = 'voronoi'
			self.patterns(type,if1.node('suboutput1'))

		if controlVariables.distColor2 != None:
			#determine grid color
			if controlVariables.distColor2=='red':
				red = sur.createNode('constant')
				red.parm('consttype').set(16)
				red.parm('colordefr').set(1)
				gridColor = sur.createNode('vectofloat')
				gridColor.setFirstInput(red)

			elif controlVariables.distColor2=='green':
				green = sur.createNode('constant')
				green.parm('consttype').set(16)
				green.parm('colordefb').set(1)
				gridColor = sur.createNode('vectofloat')
				gridColor.setFirstInput(green)

			elif controlVariables.distColor2=='blue':
				blue = sur.createNode('constant')
				blue.parm('consttype').set(16)
				blue.parm('colordefg').set(1)
				gridColor = sur.createNode('vectofloat')
				gridColor.setFirstInput(blue)

			#compare color to map
			c21 = sur.createNode('compare')
			c21.setFirstInput(gridColor)
			c21.setInput(1,mapfloat)
			c22 = sur.createNode('compare')
			c22.setFirstInput(gridColor,1)
			c22.setInput(1,mapfloat,1)
			c23 = sur.createNode('compare')
			c23.setFirstInput(gridColor,2)
			c23.setInput(1,mapfloat,2)
			
			gridand = sur.createNode('and')
			gridand.setFirstInput(c21)
			gridand.setInput(1,c22)
			gridand.setInput(2,c23)
			
			if2 = sur.createNode('if')
			if2.setFirstInput(gridand)
			controlVariables.sur = if2
			controlVariables.pattern = 'grid'
			self.patterns(type,if2.node('suboutput1'))
		
		if controlVariables.distColor3 != None:
			#determine radial color
			if controlVariables.distColor3=='red':
				red = sur.createNode('constant')
				red.parm('consttype').set(16)
				red.parm('colordefr').set(1)
				radialColor = sur.createNode('vectofloat')
				radialColor.setFirstInput(red)

			elif controlVariables.distColor3=='green':
				green = sur.createNode('constant')
				green.parm('consttype').set(16)
				green.parm('colordefb').set(1)
				radialColor = sur.createNode('vectofloat')
				radialColor.setFirstInput(green)

			elif controlVariables.distColor3=='blue':
				blue = sur.createNode('constant')
				blue.parm('consttype').set(16)
				blue.parm('colordefg').set(1)
				radialColor = sur.createNode('vectofloat')
				radialColor.setFirstInput(blue)
		
			#compare color to map
			c31 = sur.createNode('compare')
			c31.setFirstInput(radialColor)
			c31.setInput(1,mapfloat)
			c32 = sur.createNode('compare')
			c32.setFirstInput(radialColor,1)
			c32.setInput(1,mapfloat,1)
			c33 = sur.createNode('compare')
			c33.setFirstInput(radialColor,2)
			c33.setInput(1,mapfloat,2)
			
			radialand = sur.createNode('and')
			radialand.setFirstInput(c31)
			radialand.setInput(1,c32)
			radialand.setInput(2,c33)
			
			if3 = sur.createNode('if')
			if3.setFirstInput(radialand)
			controlVariables.sur = if3
			controlVariables.pattern = 'radial'
			self.patterns(type,if3.node('suboutput1'))
		
		#adding all of them together
		add = sur.createNode('add')
		add.setFirstInput(if1)
		add.setInput(1,if2)
		add.setInput(2,if3)
		
		
		if type == 'surface':
			#wire it to he output node
			out = hou.node('/vex/CityPattern/output1')
		elif type == 'filter':
			out = hou.node('/vex/myPattern/output1')
		out.setFirstInput(add)
		
		for n in sur.children():
		   n.moveToGoodPosition()



	def patterns(self,type,out):

		if controlVariables.pattern == 'voronoi':
			v = voronoise()
			v.createSurface(type,out)
		elif controlVariables.pattern == 'grid':
			g = grid()
			g.createSurface(type,out)
		elif controlVariables.pattern == 'radial':
			r = radial()
			r.createSurface(type,out)