import sys
import hou

from controlVariables import *
from regularPattern import *

class grid(regularPattern):

	def createSurface(self,type,districts=None):

		sur = controlVariables.sur
		glo = sur.createNode('global')

		#horizontal stripes
		str1 = sur.createNode('stripes')
		str1.parm('width').set(0.05)
		str1.parm('freq').set(5)
		str1.parm('blur').set(1)
	
		#vertical stripes
		str2 = sur.createNode('stripes')
		str2.parm('width').set(0.05)
		str2.parm('freq').set(5)
		str2.parm('blur').set(1)
	
		if type == 'surface':
				str1.setFirstInput(glo,11)
				str2.setFirstInput(glo,12)
		elif type == 'filter':
				str1.setFirstInput(glo,22)
				str2.setFirstInput(glo,23)
		
		add = sur.createNode('add')
		add.setFirstInput(str2)
		add.setInput(1,str1)

		if districts == None:
			if type == 'surface':
				fltovec2 = sur.createNode('floattovec')
				fltovec2.setFirstInput(add)
				fltovec2.setInput(1,add)
				fltovec2.setInput(2,add)
				
				#wire it to he output node
				out = hou.node('/vex/CityPattern/output1')
				out.setFirstInput(fltovec2)
					
			elif type == 'filter':
				out = hou.node('/vex/myPattern/output1')
				out.setFirstInput(add)
				out.setInput(1,add)
				out.setInput(2,add)
		else:
			if type == 'surface':
				fltovec2 = sur.createNode('floattovec')
				fltovec2.setFirstInput(add)
				fltovec2.setInput(1,add)
				fltovec2.setInput(2,add)
				
				#wire it to he output node
				out = districts
				out.setInput(1,fltovec2)
					
			elif type == 'filter':
				out = districts
				out.setInput(1,add)
				out.setInput(2,add)
				out.setInput(3,add)


		for n in sur.children():
			   n.moveToGoodPosition()