print "  Network module imported"

import sys
from datetime import datetime
from simpleBuilding import *
from makeHDA import *

from controlVariables import *
from PatternNetwork import *
from LoadMapNetwork import *
from readInput import *


def main(*args):
	t1 = datetime.now()

	hou.hipFile.clear() #clean the scene

	controlVariables.path = args[0]
	fileToRead = controlVariables.path + args[1]
	readInput(args[0], fileToRead)
	SimpleBuilding().createBuilding('buildingHDA', controlVariables.texturePath)
	uE = None
	if (controlVariables.loadMap == None):
		uE = uEPatternNodeFactory()
	else:
		uE = uELoadMapNodeFactory()
	createGeometry(uE)
	#makeHDA(hou.node('obj/geo1'))
	
	t2 = datetime.now()
	t3 = t2-t1
	print('La generacio ha trigat ' + str(t3.seconds) + ' segons')


def createGeometry(uE):
	#=========================================================
	#                Create City
	#=========================================================
	ma = uE.createNode('majorRoads')

	st1 = uE.createNode('stats')
	statsMajorRoadsAreaName = 'majorRoadsArea'
	st1.setName(statsMajorRoadsAreaName)
	st1.parmSet('type',1) #perim = 0, areas = 1
	st1.setFirstInput(ma)

	mi = uE.createNode('minorRoads')
	exprD = ''
	if controlVariables.useFixedMajorRoadsAreaAvg == 'None':
		exprD = 'detail("../' + statsMajorRoadsAreaName + '_avgStats","' + statsMajorRoadsAreaName + '_avgValue",0)'
	else:
		exprD = controlVariables.useFixedMajorRoadsAreaAvg
	mi.parmSet('detailExpr',exprD)
	mi.setFirstInput(st1)

	st2 = uE.createNode('stats')
	statsMinorRoadsArea = 'minorRoadsArea'
	st2.setName(statsMinorRoadsArea)
	st2.parmSet('type',1) #perim = 0, areas = 1
	st2.setFirstInput(mi)
	
	bl = uE.createNode('blocks')
	exprD = ''
	if controlVariables.useFixedMinorRoadsAreaAvg == 'None':
		exprD = 'detail("../' + statsMinorRoadsArea + '_avgStats","' + statsMinorRoadsArea + '_avgValue",0)'
	else:
		exprD = controlVariables.useFixedMinorRoadsAreaAvg
	bl.parmSet('areaExpr','prim("../' + statsMinorRoadsArea + '_Stats",$PR,"' + statsMinorRoadsArea + '_Value",0)')
	bl.parmSet('detailExpr',exprD)
	bl.setFirstInput(st2)

	st3 = uE.createNode('stats')
	statsNodeName = 'blockPerimeter'
	st3.setName(statsNodeName)
	st3.parmSet('type',0) #perim = 0, areas = 1
	st3.setFirstInput(bl)

	fi = uE.createNode('filter')
	fi.setName('visibles')
	fi.setFirstInput(st3)

	lo = uE.createNode('lots')
	exprD = ''
	if controlVariables.useFixedBlockPerimeterAvg == 'None':
		exprD = 'detail("../' + statsNodeName + '_avgStats","' + statsNodeName + '_avgValue",0)'
	else:
		exprD = controlVariables.useFixedBlockPerimeterAvg
	lo.parmSet('detailExpr',exprD)
	lo.setFirstInput(fi)

	bu = uE.createNode('buildings')
	bu.setFirstInput(lo)

	fa = uE.createNode('finalAppearance')
	fa.setFirstInput(bu)
	#fa.setNextInput(bl)

	if controlVariables.floor != None:
		fl = uE.createNode('floor')
		fl.setFirstInput(bl)
		fa.setNextInput(fl)

	uE.finishConstruction()

	print "======= STATS ========"
	print st1.name() + ": ", st1.parmEval('path')
	print st2.name() + ": ", st2.parmEval('path')
	print st3.name() + ": ", st3.parmEval('path')
