from XMLShapeFileReader import *
from controlVariables import *

def readInput(basePath, fileToRead):
	fileReader = XMLShapeFileReader(fileToRead)

	controlVariables.path = basePath
	controlVariables.loadMap = None
	controlVariables.districtMap = None
	controlVariables.waterMap = None
	controlVariables.floor = None

	fileReader.initRules()
	while not fileReader.finishedRules():
		
		pre = fileReader.getPredecessor()
	  
		fileReader.initActions()
		while not fileReader.finishedActions():
			
			actionName = fileReader.currentActionName()
			
			if actionName == 'districts':
				districtMap = fileReader.readOptionalParameters([('districtMap',None)])[0]
				if (districtMap != None):
					controlVariables.districtMap = controlVariables.path + districtMap
				controlVariables.streetsAngle = fileReader.readOptionalParameters([('angle','random')])[0]
				controlVariables.distColor1, controlVariables.distColor2, controlVariables.distColor3 = fileReader.readOptionalParameters([('colorDef1',None),('colorDef2',None),('colorDef3',None)])

				numDist = len(fileReader.getParameters()) - 2
				
				i = 0
				while i <numDist:
					fileReader.selectNextRule()
					fileReader.initActions()
					actionName = fileReader.currentActionName()
					
					if actionName == 'voronoise':
						controlVariables.voronoiDensity = fileReader.readOptionalParameters([('density','centered')])[0]
						controlVariables.voronoiFrequency = fileReader.readCompulsoryParameters(['frequency'])[0]
						controlVariables.voronoiCx, controlVariables.voronoiCy = fileReader.readCompulsoryParameters(['cy','cx'])
					elif actionName == 'grid':
						controlVariables.gridFrequencyx, controlVariables.gridFrequencyy = fileReader.readCompulsoryParameters(['freqx','freqy'])
						controlVariables.gridCx, controlVariables.gridCy = fileReader.readCompulsoryParameters(['cy','cx'])
					elif actionName == 'radial':
						controlVariables.radialFrequency, controlVariables.radialAngularFrequency = fileReader.readCompulsoryParameters(['freqRadial','freqAngular'])
						controlVariables.radialCx, controlVariables.radialCy = fileReader.readCompulsoryParameters(['cy','cx'])						
					i = i+1

			elif actionName == 'loadMap':
				controlVariables.loadMap = controlVariables.path + fileReader.readOptionalParameters([('file',None)])[0]
				controlVariables.floor = controlVariables.path + fileReader.readOptionalParameters([('floor',None)])[0]
				controlVariables.needsDelete = fileReader.readOptionalParameters([('eraseOuterPrim',None)])[0]
				controlVariables.traceThreshold = float(fileReader.readOptionalParameters([('threshold','0.5')])[0])
				if controlVariables.floor == 'None':
					controlVariables.floor = None
				controlVariables.pattern = controlVariables.loadMap
				
			elif actionName == 'landUse':
				waterMap = fileReader.readCompulsoryParameters([('waterMap')])[0]
				if waterMap != 'None':
					controlVariables.waterMap = controlVariables.path + waterMap
				
			elif actionName == 'voronoise':
				controlVariables.pattern = 'voronoi'
				controlVariables.voronoiDensity = fileReader.readOptionalParameters([('density','centered')])[0]
				controlVariables.voronoiFrequency = fileReader.readCompulsoryParameters(['frequency'])[0]
				controlVariables.voronoiCx, controlVariables.voronoiCy = fileReader.readCompulsoryParameters(['cy','cx'])
				
			elif actionName == 'grid':
				controlVariables.pattern = 'grid'
				controlVariables.gridFrequencyx, controlVariables.gridFrequencyy = fileReader.readCompulsoryParameters(['freqx','freqy'])
				controlVariables.gridCx, controlVariables.gridCy = fileReader.readCompulsoryParameters(['cy','cx'])
				
			elif actionName == 'radial':
				controlVariables.pattern = 'radial'
				controlVariables.radialFrequency, controlVariables.radialAngularFrequency = fileReader.readCompulsoryParameters(['freqRadial','freqAngular'])
				controlVariables.radialCx, controlVariables.radialCy = fileReader.readCompulsoryParameters(['cy','cx'])
				
			elif actionName == 'divideStreets':
				controlVariables.streetsAngle = fileReader.readOptionalParameters([('angle','random')])[0]
				#controlVariables.streetsDensityMin = fileReader.readCompulsoryParameters(['streetDensityMin'])[0]
				controlVariables.blockSizex, controlVariables.blockSizey = fileReader.readCompulsoryParameters([('blockSizex'),('blockSizey')])
				controlVariables.minimumPercentualSize = fileReader.readOptionalParameters([('minimumPercentualSize','0.7')])[0]
				controlVariables.useFixedMajorRoadsAreaAvg, controlVariables.useFixedMinorRoadsAreaAvg = fileReader.readOptionalParameters([('useFixedMajorRoadsAreaAvg','None'), ('useFixedMinorRoadsAreaAvg','None')])
			
			elif actionName == 'makeLots':
				controlVariables.lotsWidth = fileReader.readCompulsoryParameters(['width'])[0]
				controlVariables.useFixedBlockPerimeterAvg = fileReader.readOptionalParameters([('useFixedBlockPerimeterAvg','None')])[0]
				
			elif actionName == 'createBuildings':
				controlVariables.texturePath = controlVariables.path + fileReader.readCompulsoryParameters(['texturePath'])[0]
				controlVariables.needsReverse = fileReader.readOptionalParameters([('needsReverse','Yes')])[0]
				controlVariables.buildingScale = float(fileReader.readOptionalParameters([('buildingScale','1')])[0])
			
			fileReader.selectNextAction()

		fileReader.selectNextRule()
